#!/bin/bash

# Source file
# readfile="Info.plist"
# findpath="/usr/libexec/SmartCardServices/drivers/ifd-ccid.bundle"
# readpath="/usr/libexec/SmartCardServices/drivers/ifd-ccid.bundle/Contents/$readfile"
readpath=$1
echo "readpath = $readpath"

# For test only
#readpath="/Users/$USER/Linker/Scard/$readfile"

# Temp file
# writefile="/Users/$USER/Info.plist.ready.tmp"
writefile="./Info.plist.ready.tmp"

if [ -f "$writefile" ]; then
    rm $writefile
    echo "Old file $writefile deleted"
fi

# Test for integrity Info.plist file
BASEDIR=$(dirname $0)
# $BASEDIR/check_plist_integrity.sh $readpath
# if [ "$?" -eq 1 ]; then
#        echo $readpath is invalid. Replacing with basic one
#        sudo cp -f $BASEDIR/Info.plist $readpath
# fi

# Search previous Aladdin strings at Mac OS service file Info.plist
# 1 - insert new string / 0 - Not insert
INS1=1  # Aladdin R.D. JaCarta LT
INS2=1  # Aladdin R.D. JaCarta Flash / PID = 0x100F P
INS3=1  # Aladdin R.D. JCR-770
INS4=1  # Aladdin R.D. JaCarta
INS5=1  # Aladdin R.D. JaCarta WebPass
INS6=1  # Aladdin R.D. JaCarta Quick
INS7=1  # Aladdin R.D. JaCarta Flash / PID = 0x0403
INS8=1  # Aladdin R.D. JaCarta Premium
INS9=1  # Aladdin R.D. JaCarta TLS
INS10=1 # Aladdin R.D. JaCarta U2F
INS11=1 # iR301 / PID = 0x0619
INS12=1 # iR301 / PID = 0x061C
INS13=1 # bR301

PIDs=0      # 0/1 - PID section
Names=0     # 0/1 - Friendly Names section
PID_NUM=0   # 0/1 - Current string number in PID section
Names_NUM=0 # 0/1 - Current string number in Names section

# We suppose that single address can occure 3 times in a section
# Aladdin R.D. JaCarta Flash
Flash_100F_NUM_1=0
Flash_100F_NUM_2=0
Flash_100F_NUM_3=0

Flash_0403_NUM_1=0
Flash_0403_NUM_2=0
Flash_0403_NUM_3=0

# iR301
iR301_9_NUM_1=0
iR301_9_NUM_2=0
iR301_9_NUM_3=0

iR301_C_NUM_1=0
iR301_C_NUM_2=0
iR301_C_NUM_3=0

# read file
file=$readpath

while read line
do

if [[ $line = "<key>ifdProductID</key>" ]]; then
    PIDs=1
elif [[ $line = "<key>ifdFriendlyName</key>" ]]; then
    Names=1
elif [[ $line = "</array>" ]]; then
    PIDs=0
    Names=0
elif [[ $line != "<array>" ]]; then
    if [[ $PIDs = 1 ]]; then
        PID_NUM=$[$PID_NUM+1]

        if [[ $line = "<string>0x100F</string>" || $line = "<string>0x100f</string>" ]]; then
            if [[ $Flash_100F_NUM_1 = 0 ]]; then
                Flash_100F_NUM_1=$PID_NUM
            elif [[ $Flash_100F_NUM_2 = 0 ]]; then
                Flash_100F_NUM_2=$PID_NUM
            else
                Flash_100F_NUM_3=$PID_NUM
            fi
        elif [[ $line = "<string>0x0403</string>" ]]; then
            if [[ $Flash_0403_NUM_1 = 0 ]]; then
                Flash_0403_NUM_1=$PID_NUM
            elif [[ $Flash_0403_NUM_2 = 0 ]]; then
                Flash_0403_NUM_2=$PID_NUM
            else
                Flash_0403_NUM_3=$PID_NUM
            fi
        elif [[ $line = "<string>0x0619</string>" ]]; then
            if [[ $iR301_9_NUM_1 = 0 ]]; then
                iR301_9_NUM_1=$PID_NUM
            elif [[ $iR301_9_NUM_2 = 0 ]]; then
                iR301_9_NUM_2=$PID_NUM
            else
                iR301_9_NUM_3=$PID_NUM
            fi
        elif [[ $line = "<string>0x061C</string>" || $line = "<string>0x061c</string>" ]]; then
            if [[ $iR301_C_NUM_1 = 0 ]]; then
                iR301_C_NUM_1=$PID_NUM
            elif [[ $iR301_C_NUM_2 = 0 ]]; then
                iR301_C_NUM_2=$PID_NUM
            else
                iR301_C_NUM_3=$PID_NUM
            fi
        fi
    elif [[ $Names = 1 ]]; then
        Names_NUM=$[$Names_NUM+1]

        if [[ $line = "<string>Aladdin R.D. JaCarta LT</string>" ]]; then
            INS1=0
        elif [[ $line = "<string>Aladdin R.D. JaCarta Flash</string>" ]]; then
            if [[ $Flash_100F_NUM_1 = $Names_NUM || $Flash_100F_NUM_2 = $Names_NUM || $Flash_100F_NUM_3 = $Names_NUM ]]; then
                INS2=0
            fi
            if [[ $Flash_0403_NUM_1 = $Names_NUM || $Flash_0403_NUM_2 = $Names_NUM || $Flash_0403_NUM_3 = $Names_NUM ]]; then
                INS7=0
            fi
        elif [[ $line = "<string>Aladdin R.D. JCR-770</string>" ]]; then
            INS3=0
        elif [[ $line = "<string>Aladdin R.D. JaCarta</string>" ]]; then
            INS4=0
        elif [[ $line = "<string>Aladdin R.D. JaCarta WebPass</string>" ]]; then
            INS5=0
        elif [[ $line = "<string>Aladdin R.D. JaCarta Quick</string>" ]]; then
            INS6=0
        elif [[ $line = "<string>Aladdin R.D. JaCarta Premium</string>" ]]; then
            INS8=0
        elif [[ $line = "<string>Aladdin R.D. JaCarta TLS</string>" ]]; then
            INS9=0
        elif [[ $line = "<string>Aladdin R.D. JaCarta U2F</string>" ]]; then
            INS10=0
        elif [[ $line = "<string>iR301</string>" ]]; then
            if [[ $iR301_9_NUM_1 = $Names_NUM || $iR301_9_NUM_2 = $Names_NUM || $iR301_9_NUM_3 = $Names_NUM ]]; then
                INS11=0
            fi
            if [[ $iR301_C_NUM_1 = $Names_NUM || $iR301_C_NUM_2 = $Names_NUM || $iR301_C_NUM_3 = $Names_NUM ]]; then
                INS12=0
            fi
        elif [[ $line = "<string>bR301</string>" ]]; then
            INS13=0
        fi
    fi
fi

done < $file

# Add Aladdin strings in Mac OS service file Info.plist
echo "ins1 = $INS1"
echo "ins2 = $INS2"
echo "ins3 = $INS3"
echo "ins4 = $INS4"
echo "ins5 = $INS5"
echo "ins6 = $INS6"
echo "ins7 = $INS7"
echo "ins8 = $INS8"
echo "ins9 = $INS9"
echo "ins10 = $INS10"
echo "ins11 = $INS11"
echo "ins12 = $INS12"
echo "ins13 = $INS13"

cat $readpath |
awk '{print}
{if (/<key>ifdVendorID<\/key>/)
    {
        VID = 1
    }
    else
    {
        if (/<key>ifdProductID<\/key>/)
        {
            PID = 1
        }
        else
        {
            if (/<key>ifdFriendlyName<\/key>/)
            {
                FNAME = 1
            }
            else
            {
                if (/<array>/)
                {
                    {
                        INS1='$INS1'
                        INS2='$INS2'
                        INS3='$INS3'
                        INS4='$INS4'
                        INS5='$INS5'
                        INS6='$INS6'
                        INS7='$INS7'
                        INS8='$INS8'
                        INS9='$INS9'
                        INS10='$INS10'
                        INS11='$INS11'
                        INS12='$INS12'
                        INS13='$INS13'
                    }
                if ( VID == 1 )
                {
                    if ( INS1 == 1 )
                    {
                        {print("        <string>0x24DC</string>")}
                    }
                    if ( INS2 == 1 )
                    {
                        {print("        <string>0x24DC</string>")}
                    }
                    if ( INS3 == 1 )
                    {
                        {print("        <string>0x24DC</string>")}
                    }
                    if ( INS4 == 1 )
                    {
                        {print("        <string>0x24DC</string>")}
                    }
                    if ( INS5 == 1 )
                    {
                        {print("        <string>0x24DC</string>")}
                    }
                    if ( INS6 == 1 )
                    {
                        {print("        <string>0x24DC</string>")}
                    }
                    if ( INS7 == 1 )
                    {
                        {print("        <string>0x24DC</string>")}
                    }
                    if ( INS8 == 1 )
                    {
                        {print("        <string>0x24DC</string>")}
                    }
                    if ( INS9 == 1 )
                    {
                        {print("        <string>0x24DC</string>")}
                    }
                    if ( INS10 == 1 )
                    {
                        {print("        <string>0x24DC</string>")}
                    }
                    if ( INS11 == 1 )
                    {
                        {print("        <string>0x096E</string>")}
                    }
                    if ( INS12 == 1 )
                    {
                        {print("        <string>0x096E</string>")}
                    }
                    if ( INS13 == 1 )
                    {
                        {print("        <string>0x096E</string>")}
                    }
                    VID = 0
                }
                else
                {
                    if ( PID == 1 )
                    {
                        if ( INS1 == 1 )
                        {
                            {print("        <string>0x0102</string>")}
                        }
                        if ( INS2 == 1 )
                        {
                            {print("        <string>0x100F</string>")}
                        }
                        if ( INS3 == 1 )
                        {
                            {print("        <string>0x0201</string>")}
                        }
                        if ( INS4 == 1 )
                        {
                            {print("        <string>0x0101</string>")}
                        }
                        if ( INS5 == 1 )
                        {
                            {print("        <string>0x0401</string>")}
                        }
                        if ( INS6 == 1 )
                        {
                            {print("        <string>0x0402</string>")}
                        }
                        if ( INS7 == 1 )
                        {
                            {print("        <string>0x0403</string>")}
                        }
                        if ( INS8 == 1 )
                        {
                            {print("        <string>0x0404</string>")}
                        }
                        if ( INS9 == 1 )
                        {
                            {print("        <string>0x0405</string>")}
                        }
                        if ( INS10 == 1 )
                        {
                            {print("        <string>0x0501</string>")}
                        }
                        if ( INS11 == 1 )
                        {
                            {print("        <string>0x0619</string>")}
                        }
                        if ( INS12 == 1 )
                        {
                            {print("        <string>0x061C</string>")}
                        }
                        if ( INS13 == 1 )
                        {
                            {print("        <string>0x061A</string>")}
                        }
                        PID = 0
                    }
                    else
                    {
                        if ( FNAME == 1 )
                        {
                            if ( INS1 == 1 )
                            {
                                {print("        <string>Aladdin R.D. JaCarta LT</string>")}
                            }
                            if ( INS2 == 1 )
                            {
                                {print("        <string>Aladdin R.D. JaCarta Flash</string>")}
                            }
                            if ( INS3 == 1 )
                            {
                                {print("        <string>Aladdin R.D. JCR-770</string>")}
                            }
                            if ( INS4 == 1 )
                            {
                                {print("        <string>Aladdin R.D. JaCarta</string>")}
                            }
                            if ( INS5 == 1 )
                            {
                                {print("        <string>Aladdin R.D. JaCarta WebPass</string>")}
                            }
                            if ( INS6 == 1 )
                            {
                                {print("        <string>Aladdin R.D. JaCarta Quick</string>")}
                            }
                            if ( INS7 == 1 )
                            {
                                {print("        <string>Aladdin R.D. JaCarta Flash</string>")}
                            }
                            if ( INS8 == 1 )
                            {
                                {print("        <string>Aladdin R.D. JaCarta Premium</string>")}
                            }
                            if ( INS9 == 1 )
                            {
                                {print("        <string>Aladdin R.D. JaCarta TLS</string>")}
                            }
                            if ( INS10 == 1 )
                            {
                                {print("        <string>Aladdin R.D. JaCarta U2F</string>")}
                            }
                            if ( INS11 == 1 )
                            {
                                {print("        <string>iR301</string>")}
                            }
                            if ( INS12 == 1 )
                            {
                                {print("        <string>iR301</string>")}
                            }
                            if ( INS13 == 1 )
                            {
                                {print("        <string>bR301</string>")}
                            }
                            FNAME = 0
                        }
                    }
                }
                }
            }
        }
    }
}' > $writefile

# Test for integrity Info.plist file
$BASEDIR/check_plist_integrity.sh $writefile

if [ "$?" -eq 0 ]; then
    chown --reference=$readpath $writefile
    chmod --reference=$readpath $writefile
    mv -f $writefile $readpath
    echo "$readpath updated"
    exit 0
else
    echo "FATAL ERROR: $writefile is invalid."
    echo "Error adding new strings."
    echo "$readpath NOT updated"
    exit 1
fi

